import { BaseCacheLoader, CacheOptions } from './BaseCacheLoader';
/**
 * Cache class allowing to create caches with automatic cache loading and delegates.
 */
export declare abstract class CacheLoader<K extends Object, V extends Object> extends BaseCacheLoader<K, V> {
    /**
     * Constructor.
     *
     * @param {String} cacheId the identifier of the cache
     * @param {CacheOptions} options the cache options:
     */
    protected constructor(cacheId: string, options?: CacheOptions);
}
