export interface CacheFlowConfiguration {
    redis?: RedisCacheConfiguration;
    logger?: LoggerInterface;
}
export interface RedisCacheConfiguration {
    host: string;
    port: number;
    db?: number;
}
export interface LoggerInterface {
    log(...args: any[]): void;
    debug(message: any, ...args: any[]): void;
    info(message: any, ...args: any[]): void;
    warn(message: any, ...args: any[]): void;
    error(message: any, ...args: any[]): void;
}
export declare class DefaultLogger implements LoggerInterface {
    log(...args: any[]): void;
    debug(message: any, ...args: any[]): void;
    info(message: any, ...args: any[]): void;
    warn(message: any, ...args: any[]): void;
    error(message: any, ...args: any[]): void;
}
